#ifndef __CAFFEINEAPPVIEW_H
#define __CAFFEINEAPPVIEW_H

#include <coecntrl.h>

class SymbianCaffeine;

class CCaffeineAppView : public CCoeControl, public MDirectScreenAccess {
public:

	enum TDrawMode { EDoubleBuf, EDSA };

	static CCaffeineAppView* NewL(const TRect& aRect);
	static CCaffeineAppView* NewLC(const TRect& aRect);
	~CCaffeineAppView();

	TKeyResponse OfferKeyEventL(const TKeyEvent& aKeyEvent, TEventCode aType);

	void Draw(const TRect& aRect) const;
	static int StaticCallback(TAny* aArg);

	void SizeChanged();

	void SetForeground(TBool aForeground);

	void Restart(RDirectScreenAccess::TTerminationReasons aReason);
	void AbortNow(RDirectScreenAccess::TTerminationReasons aReason);

	void SetDrawMode(TDrawMode aMode, TBool aReset = EFalse);

	void HandleResourceChange(TInt aType);

private:
	void ConstructL(const TRect& aRect);
	CCaffeineAppView();

private:

	void SetupBitmap();
	void Update();
	void Callback();
	void SetDrawing(TBool aDrawing);


	CPeriodic* iPeriodic;

	CFbsBitmap* iBitmap;
	CFbsBitmapDevice* iDevice;
	CDirectScreenAccess* iDrawer;
	TBool iDSAStarted;
	TBool iForeground;

	TBool iInCallback;

	CFbsBitGc* iGc;

	TInt iFrame;
	TInt iPeriod;
	TUint iLastFPSTime;
	TInt iLastFPSFrame;
	TInt iLastFPS;
	TBool iStarted;
	TInt iLastTick;
	TUint iTime;
	TInt iFrameTickLength;
	TInt *iFrameTick;
	TInt iRelTick;
	TInt iLastResetTick;

	TDrawMode iDrawMode;

public:
	SymbianCaffeine *iCaffeine;
};

#endif
