#ifndef __CUBE_H
#define __CUBE_H

struct vector {
	float x,y,z;
};

class Cube {
	public:
		Cube(int width, int height, int bpp, int pitch, unsigned int c);
		~Cube(void);
		void init(void);
		void draw(unsigned char *buffer, int time, bool clear=true);
	private:
		void drawVertexLine(struct vector *v1, struct vector *v2, unsigned char *buffer);
		void getScreenCoord(struct vector *v, int *x, int *y);
		void drawLine(int x1, int y1, int x2, int y2, unsigned char *buffer);
		void drawLine16(int x1, int y1, int x2, int y2, unsigned short *buffer);
		void drawLine32(int x1, int y1, int x2, int y2, unsigned int *buffer);
		int width, height, bpp, pitch;
		unsigned int color;
		struct vector v[8];
		struct vector rotateVector;
		int lastTime;

		float screenZ, screenY1, screenY2, screenX1, screenX2;
};

#endif
