#ifndef __MODPLAYER_H
#define __MODPLAYER_H

#include "modfile.h"

class ModPlayer {
	public:
		ModPlayer(ModFile *mf, int channels=2, int samplerate=44100, int bitdepth=16, bool sig=true, bool littleendian=true);
		~ModPlayer(void);
		int read(unsigned char *buffer, int length);
		void addPatternCallback(void (*callback)(int orderNr, void *data), void *userdata);
		void addRowCallback(void (*callback)(int row, int patternNr, int orderNr, int length, void *data), void *userdata);
		void addHitCallback(void (*callback)(int channel, void *data), void *userdata);
		void fadeOut(void);
		void fadeOut(int length);
		bool isRunning(void);
	private:
		ModFile *mod;
		int outChannels, samplerate, bitdepth;
		bool sig, littleendian;

		bool running, started;
		int speed, tick, row, bpm;
		int tickLength, tickPos;
		int orderNr, currentPattern, patternOffset;
		int *lastInstrument, *origVolume, *volume;
		int *tone, *amiga, *frequency, *pan;

		int *portaSpeed, *portaNote;
		int *vibratoPos, *vibratoPar, *vibratoType;
		int *tremoloPos, *tremoloPar, *tremoloType;
		bool *vibratoNeg, *tremoloNeg, *glissando;
		int loopRow, loopNum, patternDelay;

		int frameSize, *lastPos;

		bool fade;
		int fadePos, fadeLength;

		void (*patternCallback)(int orderNr, void *data);
		void (*rowCallback)(int row, int patternNr, int orderNr, int length, void *data);
		void (*hitCallback)(int channel, void *data);
		void *patternData;
		void *rowData;
		void *hitData;

		void updateSpeed(void);
		void timer(void);
		void updateRow(void);
		void updateEffect(void);
		void nextPattern(void);

		int getFrameSize(void);
		void convert(unsigned char **bufferptr, int l, int r);
};

int ModPlayer_read(void *ptr, unsigned char *buffer, int length);

#endif
