#ifndef __SHOWTEXT_H
#define __SHOWTEXT_H

class ShowText {
	public:
		ShowText(int width, int height, int bpp, int pitch);
		~ShowText(void);
		void init(void);
		void setFont(unsigned char *font, char *chars, bool lowerCase, int charWidth, int charHeight, int width, bool plain, unsigned int color);
		void setText(char **text, int time);
		void draw(unsigned char *buffer, int time);
	private:
		void drawString(unsigned char *buffer, char *string);
		void drawRow(unsigned char *buffer, char *row, int y);
		void drawChar(unsigned char *buffer, char c, int bufferX, int bufferY);
		void drawOverlay(unsigned char *buffer, unsigned char *overlay, int x, int y);
		int getIndex(char c);
		int width, height, bpp, pitch;
		unsigned char *font;
		char *fontChars;
		bool lowerCase;
		int charWidth, charHeight;
		int fontImageWidth;
		bool plain;
		unsigned int color;
		unsigned char **texts;
		int textNum;
		int bufferWidth, bufferHeight;
		int textTime;
		int startTime;
};

#endif
