#ifndef __SYMBIANCAFFEINE_H
#define __SYMBIANCAFFEINE_H

#include <e32base.h>
#include "caffeine.h"

class CFbsBitmap;
class CWaveStream;
class CModGenerator;

class SymbianCaffeine : public Caffeine {
public:
	SymbianCaffeine(int width, int height, int bpp, int pitch);
	~SymbianCaffeine();

	unsigned char *loadTitle(int *widthPtr, int *heightPtr, int *pitchPtr);
	unsigned char *loadFont(int *widthPtr, int *heightPtr, int *pitchPtr);
	unsigned char *loadBumpMap(int *widthPtr, int *heightPtr, int *pitchPtr, bool tileable);
	unsigned char *loadText(int *widthPtr, int *heightPtr, int *pitchPtr);

	void freeTitle();
	void freeFont();
	void freeBumpMap();
	void freeText();

	FILE *loadMod();

	bool initAudio();
	void startAudio(void (*callback)(int orderNr, void *data));
	void stopAudio();

	void SetPlayer(ModPlayer* aPlayer);
	void EnableMusic(TBool aEnable);

	TInt GetVolume();

private:
	TBuf<100> iBitmapFilename;
	CFbsBitmap *iTitle;
	CFbsBitmap *iBumpMap;
	CFbsBitmap *iText;
	unsigned char *iFont;
	char iModFilename[100];

	unsigned char *LoadBitmapL(CFbsBitmap*& aBitmap, TInt aId, int *widthPtr, int *heightPtr, int *pitchPtr);
	void FreeBitmap(CFbsBitmap*& aBitmap);

	CWaveStream* iStream;
	CModGenerator* iGenerator;
	TBool iMusicStarted;
};

#endif
