#include <avkon.hrh>
#include <aknnotewrappers.h>
#include <stringloader.h>
#include <flogger.h>

#include "caffeineappui.h"
#include "caffeineappview.h"

#include <caffeine.rsg>
#include "caffeine.pan"
#include "caffeineappui.h"
#include "caffeineappview.h"
#include "caffeine.hrh"
#include "symbiancaffeine.h"

void CCaffeineAppUi::ConstructL() {
	BaseConstructL();
	iAppView = CCaffeineAppView::NewL(ClientRect());
	AddToStackL(iAppView);
}

CCaffeineAppUi::CCaffeineAppUi() {
}

CCaffeineAppUi::~CCaffeineAppUi() {
	if (iAppView) {
		RemoveFromStack(iAppView);
		delete iAppView;
		iAppView = NULL;
	}
}

void CCaffeineAppUi::DoExit() {
	Exit();
}

void CCaffeineAppUi::HandleCommandL(TInt aCommand) {
	switch(aCommand) {
	case EEikCmdExit:
	case EAknSoftkeyExit:
	case EAknSoftkeyBack:
		Exit();
		break;

	default:
		Panic(ECaffeineUi);
		break;
	}
}

void CCaffeineAppUi::HandleForegroundEventL(TBool aForeground) {
	iAppView->SetForeground(aForeground);
	if (iAppView->iCaffeine)
		iAppView->iCaffeine->EnableMusic(aForeground);
}

void CCaffeineAppUi::SetEmphasis(CCoeControl* aMenuControl, TBool aEmphasis) {
	iAppView->SetForeground(!aEmphasis);
}

void CCaffeineAppUi::DynInitMenuBarL(TInt aResourceId, CEikMenuBar* aMenuBar) {
	iAppView->SetForeground(EFalse);
}



