#include <stdlib.h>
#include <math.h>
#include "invert.h"

#ifndef M_PI
#define M_PI 3.141592654
#endif

Invert::Invert(int w, int h, int b, int p) {
	width = w;
	height = h;
	bpp = b;
	pitch = p;
	sintable = NULL;
	offset = w/4;
	div1 = 800/w;
	div2 = 256*256*3/w;
}

Invert::~Invert(void) {
	free(sintable);
}

void Invert::init(void) {
	sintable = (unsigned char*) malloc(sizeof(char)*512);
	for (int i = 0; i < 512; i++)
		sintable[i] = (int) (128+127*sin(2*M_PI*i/512));
}

void Invert::draw(unsigned char *buffer, int time) {
	int xPos;
	if (bpp <= 16) {
		unsigned short *outptr = (unsigned short*) buffer;
		int spitch = pitch/2;
		for (int y = 0; y < height; y++) {
			xPos = offset + sintable[(y-time/5)&0x01FF]/div1 + (25+sintable[(y*2-time/7)&0x01FF]/2)*sintable[(y*10+2*time/3)&0x01FF]/div2;
			for (int x = 0; x < xPos; x++) {
				*outptr = ~*outptr;
				outptr++;
			}
			outptr += spitch - xPos;
		}
	} else {
		unsigned int *outptr = (unsigned int*) buffer;
		int ipitch = pitch/4;
		for (int y = 0; y < height; y++) {
			xPos = offset + sintable[(y-time/5)&0x01FF]/div1 + (25+sintable[(y*2-time/7)&0x01FF]/2)*sintable[(y*10+2*time/3)&0x01FF]/div2;
			for (int x = 0; x < xPos; x++) {
				*outptr = ~*outptr;
				outptr++;
			}
			outptr += ipitch - xPos;
		}
	}
}

