#include <stdio.h>
#include <stdlib.h>
#include <png.h>
#include "loadpng.h"

unsigned int *loadPng(FILE *in, int *outWidth, int *outHeight, bool littleendian) {
	unsigned char header[8];
	png_uint_32 width, height;
	int bitdepth, colortype;
	int rowbytes;
//	int channels;
	unsigned char *buffer;
/*	unsigned char *inptr, a, r, g, b;
	unsigned int *data, *outptr;
*/	png_bytep *row_pointers;
	unsigned int i;
//	unsigned int j;

	fread(header,1,8,in);
	if (png_sig_cmp(header,0,8)) return NULL;

	png_structp png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING,NULL,NULL,NULL);
	if (png_ptr==NULL) return NULL;

	png_infop info_ptr = png_create_info_struct(png_ptr);
	if (info_ptr==NULL) {
		png_destroy_read_struct(&png_ptr,NULL,NULL);
		return NULL;
	}

	png_infop end_info = png_create_info_struct(png_ptr);
	if (end_info==NULL) {
		png_destroy_read_struct(&png_ptr,&info_ptr,NULL);
		return NULL;
	}

	if (setjmp(png_ptr->jmpbuf)) {
		png_destroy_read_struct(&png_ptr,&info_ptr,&end_info);
		return NULL;
	}

	png_init_io(png_ptr,in);

	png_set_sig_bytes(png_ptr,8);

	png_read_info(png_ptr,info_ptr);

	png_get_IHDR(png_ptr,info_ptr,&width,&height,&bitdepth,&colortype,NULL,NULL,NULL);
//	channels = png_get_channels(png_ptr,info_ptr);

	if (colortype==PNG_COLOR_TYPE_PALETTE && bitdepth<=8) png_set_expand(png_ptr);
	if (colortype==PNG_COLOR_TYPE_GRAY && bitdepth<8) png_set_expand(png_ptr);
	if (png_get_valid(png_ptr,info_ptr,PNG_INFO_tRNS)) png_set_expand(png_ptr);
	if (bitdepth==16) png_set_strip_16(png_ptr);
	if (littleendian) {
		png_set_bgr(png_ptr);
		if (colortype!=PNG_COLOR_TYPE_RGB_ALPHA && colortype!=PNG_COLOR_TYPE_GRAY_ALPHA) png_set_filler(png_ptr,0xFF,PNG_FILLER_AFTER);
	} else {
		if (colortype!=PNG_COLOR_TYPE_RGB_ALPHA && colortype!=PNG_COLOR_TYPE_GRAY_ALPHA) png_set_filler(png_ptr,0xFF,PNG_FILLER_BEFORE);
		if (colortype==PNG_COLOR_TYPE_RGB_ALPHA) png_set_swap_alpha(png_ptr); // switch to ARGB
	}
	if (colortype==PNG_COLOR_TYPE_GRAY || colortype==PNG_COLOR_TYPE_GRAY_ALPHA) png_set_gray_to_rgb(png_ptr);

	png_read_update_info(png_ptr,info_ptr);
	rowbytes = png_get_rowbytes(png_ptr,info_ptr);

	row_pointers = (png_bytep*) malloc(sizeof(png_bytep)*height);
	buffer = (unsigned char*) malloc(rowbytes*height);
	for (i = 0; i < height; i++)
		row_pointers[i] = ((png_byte*)buffer)+rowbytes*i;
	png_read_image(png_ptr,row_pointers);
	free(row_pointers);

	png_read_end(png_ptr,end_info);
	png_destroy_read_struct(&png_ptr,&info_ptr,&end_info);

/*
	data = (unsigned int*) malloc(width*height*sizeof(int));
	inptr = buffer;
	outptr = data;
	for (i = 0; i < height; i++) {
		for (j = 0; j < width; j++) {
			a = *inptr++;
			r = *inptr++;
			g = *inptr++;
			b = *inptr++;
			*outptr++ = (a<<24)|(r<<16)|(g<<8)|b;
		}
	}
	free(buffer);
*/
	if (outWidth!=NULL) *outWidth = width;
	if (outHeight!=NULL) *outHeight = height;
//	return data;
	return (unsigned int*) buffer;
}

