#include <stdlib.h>
#include <string.h>
#include "mini.h"


Mini::Mini(int w, int h, int b, int p) {
	width = w;
	height = h;
	bpp = b;
	pitch = p;
	miniBuffer = NULL;
}

Mini::~Mini(void) {
	free(miniBuffer);
}

void Mini::init(void) {
	miniBuffer = (unsigned char*) malloc(((bpp + 7)/8)*(width/4)*(height/4));
}

void Mini::draw(unsigned char *buffer) {
	int bytes = (bpp + 7)/8;

	if (bpp <= 16) {
		unsigned short *outptr = (unsigned short*) miniBuffer;
		unsigned short *inptr;
		int spitch = pitch/2;
		for (int y = 0; y < height; y += 4) {
			inptr = ((unsigned short*)buffer) + y*spitch;
			for (int x = 0; x < width; x += 4) {
				*outptr++ = *inptr;
				inptr += 4;
			}
		}
	} else {
		unsigned int *outptr = (unsigned int*) miniBuffer;
		unsigned int *inptr;
		int ipitch = pitch/4;
		for (int y = 0; y < height; y += 4) {
			inptr = ((unsigned int*)buffer) + y*ipitch;
			for (int x = 0; x < width; x += 4) {
				*outptr++ = *inptr;
				inptr += 4;
			}
		}
	}

	unsigned char* inptr = miniBuffer;
	unsigned char* outptr = buffer;
	for (int i = 0; i < height/4; i++) {
		memcpy(outptr, inptr, bytes*width/4);
		inptr += bytes*width/4;
		outptr += pitch;
	}
}


